/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package se.softstuff.nb.nbtranslate.manager;

import se.softstuff.nb.nbtranslate.manager.node.ModuleChildFactory;
import java.awt.EventQueue;
import java.awt.KeyEventDispatcher;
import java.awt.KeyboardFocusManager;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.IOException;
import java.util.Locale;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
//import org.openide.util.ImageUtilities;
import org.netbeans.api.settings.ConvertAsProperties;
import org.netbeans.swing.etable.QuickFilter;
import org.netbeans.swing.outline.Outline;
import org.openide.DialogDescriptor;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.NotifyDescriptor.Confirmation;
import org.openide.cookies.EditCookie;
import org.openide.cookies.SaveCookie;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerUtils;
import org.openide.explorer.view.OutlineView;
import org.openide.loaders.DataObject;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;
import org.openide.util.lookup.ProxyLookup;
import se.softstuff.nb.nbtranslate.data.NbTranslation;
import se.softstuff.nb.nbtranslate.data.NbTranslationDataObject;
import se.softstuff.nb.nbtranslate.editor.NbBundleEditManager;
import se.softstuff.nb.nbtranslate.marker.StartKeyListener;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(
    dtd = "-//se.softstuff.nb.nbtranslate.manager//Manager//EN",
autostore = false)
public final class ManagerTopComponent extends TopComponent implements PropertyChangeListener, ExplorerManager.Provider {

    private NbTranslationDataObject translationFile;

    private NbTranslation translation;

    private InstanceContent ic;

    private static ManagerTopComponent instance;

    private OutlineView outlineView;

    private ExplorerManager explorer;

    /**
     * path to the icon used by the component and its open action
     */
//    static final String ICON_PATH = "SET/PATH/TO/ICON/HERE";
    private static final String PREFERRED_ID = "ManagerTopComponent";

    public ManagerTopComponent() {


        String originName = "origin"; //NOI18N
        String originDisplayName = NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.outlineView.header.origin");//NOI18N
        String changedName = "changed"; //NOI18N
        String changedDisplayName = NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.outlineView.header.changed");//NOI18N
        outlineView = new OutlineView();
        outlineView.setPropertyColumns(originName, originDisplayName, changedName, changedDisplayName);

        Outline outline = outlineView.getOutline();
        outline.setRootVisible(false);

        explorer = new ExplorerManager();

        initComponents();
        setName(NbBundle.getMessage(ManagerTopComponent.class, "CTL_ManagerTopComponent"));
        setToolTipText(NbBundle.getMessage(ManagerTopComponent.class, "HINT_ManagerTopComponent"));

        ic = new InstanceContent();
        Lookup icLookup = new AbstractLookup(ic);
        Lookup explorerLookup = ExplorerUtils.createLookup(explorer, getActionMap());

        associateLookup(new ProxyLookup(icLookup, explorerLookup));

        final KeyStroke markerKey = KeyStroke.getKeyStroke(KeyEvent.VK_M, KeyEvent.CTRL_DOWN_MASK | KeyEvent.SHIFT_DOWN_MASK | KeyEvent.ALT_DOWN_MASK);
        KeyEventDispatcher shourtcutFinder = new StartKeyListener(markerKey);
        KeyboardFocusManager keyboardFocusManager = KeyboardFocusManager.getCurrentKeyboardFocusManager();
        keyboardFocusManager.addKeyEventDispatcher(shourtcutFinder);

        KeyStroke saveStroke = KeyStroke.getKeyStroke(KeyEvent.VK_S, KeyEvent.CTRL_DOWN_MASK);
        Action saveAction = new MySaveAction();
        getInputMap(WHEN_FOCUSED).put(saveStroke, "save translation");
        getActionMap().put("save translation", saveAction);


    }

    @Override
    public ExplorerManager getExplorerManager() {
        return explorer;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        translationPanel = new javax.swing.JPanel();
        nodeScrollPane = outlineView;
        filterTextField = new javax.swing.JTextField();
        filterButton = new javax.swing.JButton();
        filterComboBox = new javax.swing.JComboBox();
        searchPanel1 = new se.softstuff.nb.nbtranslate.manager.SearchPanel();
        omegaTPanel1 = new se.softstuff.nb.nbtranslate.omegat.OmegaTPanel();
        settingsPanel = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        langTextField = new javax.swing.JTextField();
        curLangTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jLabel1.text")); // NOI18N

        filterTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterTextFieldActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(filterButton, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.filterButton.text")); // NOI18N
        filterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterButtonActionPerformed(evt);
            }
        });

        filterComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Origin", "Changed" }));

        javax.swing.GroupLayout translationPanelLayout = new javax.swing.GroupLayout(translationPanel);
        translationPanel.setLayout(translationPanelLayout);
        translationPanelLayout.setHorizontalGroup(
            translationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(translationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(translationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(nodeScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 794, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, translationPanelLayout.createSequentialGroup()
                        .addGap(0, 385, Short.MAX_VALUE)
                        .addComponent(filterTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 265, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(filterComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(filterButton)))
                .addContainerGap())
        );
        translationPanelLayout.setVerticalGroup(
            translationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(translationPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(translationPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(filterTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(filterButton)
                    .addComponent(filterComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(nodeScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 287, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab(org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.translationPanel.TabConstraints.tabTitle"), new javax.swing.ImageIcon(getClass().getResource("/se/softstuff/nb/nbtranslate/manager/nb_translate.png")), translationPanel); // NOI18N
        jTabbedPane1.addTab(org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.searchPanel1.TabConstraints.tabTitle"), new javax.swing.ImageIcon(getClass().getResource("/se/softstuff/nb/nbtranslate/manager/find.gif")), searchPanel1); // NOI18N
        jTabbedPane1.addTab(org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.omegaTPanel1.TabConstraints.tabTitle"), new javax.swing.ImageIcon(getClass().getResource("/se/softstuff/nb/nbtranslate/manager/OmegaT_small.gif")), omegaTPanel1); // NOI18N

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jPanel3.border.title"))); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jButton1, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jButton1.text")); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        curLangTextField.setEditable(false);

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jLabel2.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel5, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jLabel5.text")); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(curLangTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(langTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButton1)))
                .addContainerGap(13, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(curLangTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(langTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.openide.awt.Mnemonics.setLocalizedText(jButton2, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jButton2.text")); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jButton3, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jButton3.text")); // NOI18N
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout settingsPanelLayout = new javax.swing.GroupLayout(settingsPanel);
        settingsPanel.setLayout(settingsPanelLayout);
        settingsPanelLayout.setHorizontalGroup(
            settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(settingsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jButton3)
                    .addComponent(jButton2)
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(503, Short.MAX_VALUE))
        );
        settingsPanelLayout.setVerticalGroup(
            settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(settingsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton3)
                .addContainerGap(136, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab(org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.settingsPanel.TabConstraints.tabTitle"), settingsPanel); // NOI18N

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/se/softstuff/nb/nbtranslate/manager/save.png"))); // NOI18N
        org.openide.awt.Mnemonics.setLocalizedText(saveButton, org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.saveButton.text")); // NOI18N
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jTextPane1.setEditable(false);
        jTextPane1.setText(org.openide.util.NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.jTextPane1.text")); // NOI18N
        jScrollPane2.setViewportView(jTextPane1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(saveButton)
                        .addGap(60, 60, 60)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 305, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel1)
                        .addComponent(saveButton))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jTabbedPane1))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        String[] part = langTextField.getText().trim().split("_");


        Locale locale;
        switch (part.length) {
            case 0:
                locale = new Locale("");
                break;
            case 1:
                locale = new Locale(part[0]);
                break;
            case 2:
                locale = new Locale(part[0], part[1]);
                break;
            case 3:
                locale = new Locale(part[0], part[1], part[2]);
                break;
            default:
                throw new IllegalArgumentException("Language fiald has to meny dashes");
        }

        Locale.setDefault(locale);

        curLangTextField.setText(locale.toString());
        langTextField.setText("");

    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        translationFile.getCookie(EditCookie.class).edit();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed

        NbBundleEditManager manager = NbBundleEditManager.getInstance();
        manager.clearBundleCache();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void filterButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterButtonActionPerformed
        filter();
    }//GEN-LAST:event_filterButtonActionPerformed

    private void filterTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterTextFieldActionPerformed
        filter();
    }//GEN-LAST:event_filterTextFieldActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed

        if(!translationFile.isModified()){
            return; // ignore
        }
        try {
            translationFile.getCookie(SaveCookie.class).save();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField curLangTextField;
    private javax.swing.JButton filterButton;
    private javax.swing.JComboBox filterComboBox;
    private javax.swing.JTextField filterTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTextField langTextField;
    private javax.swing.JScrollPane nodeScrollPane;
    private se.softstuff.nb.nbtranslate.omegat.OmegaTPanel omegaTPanel1;
    private javax.swing.JButton saveButton;
    private se.softstuff.nb.nbtranslate.manager.SearchPanel searchPanel1;
    private javax.swing.JPanel settingsPanel;
    private javax.swing.JPanel translationPanel;
    // End of variables declaration//GEN-END:variables

    /**
     * Gets default instance. Do not use directly: reserved for *.settings files
     * only, i.e. deserialization routines; otherwise you could get a
     * non-deserialized instance. To obtain the singleton instance, use
     * {@link #findInstance}.
     */
    public static synchronized ManagerTopComponent getDefault() {
        if (instance == null) {
            instance = new ManagerTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the ManagerTopComponent instance. Never call {@link #getDefault}
     * directly!
     */
    public static synchronized ManagerTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(ManagerTopComponent.class.getName()).warning(
                    "Cannot find " + PREFERRED_ID + " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof ManagerTopComponent) {
            return (ManagerTopComponent) win;
        }
        Logger.getLogger(ManagerTopComponent.class.getName()).warning(
                "There seem to be multiple components with the '" + PREFERRED_ID
                + "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    @Override
    public void componentOpened() {
        initList();
        initLocale();
    }

    @Override
    public void componentClosed() {


        this.translationFile.removePropertyChangeListener(this);

        NbBundleEditManager manager = NbBundleEditManager.getInstance();
        try {
            manager.detach();
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }
    }

    @Override
    public boolean canClose() {
        if (translationFile != null && translationFile.isModified()) {
            Confirmation dialog = new DialogDescriptor.Confirmation(
                    NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.savedialog.message"),
                    NbBundle.getMessage(ManagerTopComponent.class, "ManagerTopComponent.savedialog.title"),
                    NotifyDescriptor.YES_NO_CANCEL_OPTION);

            Object answer = DialogDisplayer.getDefault().notify(dialog);
            if (answer == NotifyDescriptor.YES_OPTION) {

                SaveCookie cookie = translationFile.getLookup().lookup(SaveCookie.class);
                try {
                    cookie.save();
                } catch (IOException ex) {
                    Exceptions.printStackTrace(ex);
                }
                return true;
            } else if (answer == NotifyDescriptor.CANCEL_OPTION) {
                return false;
            }
        }

        return true;
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    Object readProperties(java.util.Properties p) {
        if (instance == null) {
            instance = this;
        }
        instance.readPropertiesImpl(p);
        return instance;
    }

    private void readPropertiesImpl(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    public boolean loadDataObject(NbTranslationDataObject translationFile) {
        if (this.translationFile != null && this.translationFile.isModified()) {
            boolean closed = handleOldFile();
            if (!closed) {
                return false;
            }
        }

        this.translationFile = translationFile;
        this.translation = translationFile.getContent();
        ic.add(translationFile);
        ic.add(translation);


        setNameFromFile();

        this.translationFile.addPropertyChangeListener(this);
        this.translation.addPropertyChangeListener(this);

        omegaTPanel1.setTranslationFile(translationFile);
        searchPanel1.setTranslation(translation);

        NbBundleEditManager manager = NbBundleEditManager.getInstance();
        try {
            manager.attach(translationFile);
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        }

        return true;
    }

    private boolean handleOldFile() {
        return true;
    }

    private void setNameFromFile() {

        Runnable task = new Runnable() {
            @Override
            public void run() {
                saveButton.setEnabled(translationFile.isModified());

                String fileName = translationFile.getPrimaryFile().getNameExt();
                setName(fileName);
                if (translationFile.isModified()) {
                    fileName = String.format("<html><b>%s<b/></html>", fileName);
                }
                setHtmlDisplayName(fileName);
            }
        };

        EventQueue.invokeLater(task);
    }

    @Override
    public void propertyChange(PropertyChangeEvent evt) {

        if (evt.getPropertyName().equals(DataObject.PROP_MODIFIED)) {
            setNameFromFile();

        }

        if (evt.getPropertyName().equals(NbTranslation.PROP_RESOURCE_CHANGES)) {
            initList();
        }
    }

    private void initList() {

        Children kids = Children.create(new ModuleChildFactory(translation), true);

        //Create a root node:
        Node rootNode = new AbstractNode(kids);
        explorer.setRootContext(rootNode);
    }

    private void initLocale() {
        curLangTextField.setText(Locale.getDefault().toString());
    }


    private void filter(){
        final String textToFind = filterTextField.getText();
        if (textToFind.isEmpty()) {
            outlineView.getOutline().unsetQuickFilter();
        } else {
            QuickFilter find = new QuickFilter() {
                @Override
                public boolean accept(Object o) {
                    if (o instanceof String) {
                        String text = (String) o;
                        return text.contains(textToFind);
                    }
                    return false;
                }
            };
            int column = filterComboBox.getSelectedIndex();
            if(column == -1){
                column = 0;
            }
            outlineView.getOutline().setQuickFilter(column+1, find);
        }
    }

    private class MySaveAction extends AbstractAction {

        @Override
        public void actionPerformed(ActionEvent e) {
            if (translationFile != null && translationFile.isModified()) {
                SaveCookie cookie = translationFile.getLookup().lookup(SaveCookie.class);
                try {
                    cookie.save();
                } catch (IOException ex) {
                    Exceptions.printStackTrace(ex);
                }
            }
        }
    }
}
